---
title: 'RTCPeerConnection: iceconnectionstatechange event'
slug: Web/API/RTCPeerConnection/iceconnectionstatechange_event
tags:
  - API
  - Connection
  - Connectivity
  - Disconnect
  - ICE
  - Media
  - RTCPeerConnection
  - Reference
  - WebRTC
  - WebRTC API
  - events
  - iceConnectionState
  - iceconnectionstatechange
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">An <strong><code>iceconnectionstatechange</code></strong> event is sent to an {{domxref("RTCPeerConnection")}} object each time the {{Glossary("ICE")}} connection state changes during the negotiation process.</span> The new ICE connection state is available in the object's {{domxref("RTCPeerConnection.iceConnectionState", "iceConnectionState")}}} property.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{DOMxRef("RTCPeerConnection.oniceconnectionstatechange", "oniceconnectionstatechange")}}</td>
  </tr>
 </tbody>
</table>

<p>One common task performed by the <code>iceconnectionstatechange</code> event listener: to trigger ICE restart when the state changes to <code>failed</code>. See {{SectionOnPage("/en-US/docs/Web/API/WebRTC_API/Session_lifetime", "ICE restart")}} for further information.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>A successful connection attempt will typically involve the state starting at <code>new</code>, then transitioning through <code>checking</code>, then <code>connected</code>, and finally <code>completed</code>. However, under certain circumstances, the <code>connected</code> state can be skipped, causing a connection to transition directly from the <code>checking</code> state to <code>completed</code>. This can happen when only the last checked candidate is successful, and the gathering and end-of-candidates signals both occur before the successful negotiation is completed.</p>

<h3 id="ICE_connection_state_during_ICE_restarts">ICE connection state during ICE restarts</h3>

<p>When an ICE restart is processed, the gathering and connectivity checking process is started over from the beginning, which will cause the <code>iceConnectionState</code> to transition to <code>connected</code> if the ICE restart was triggered while in the <code>completed</code> state. If ICE restart is initiated while in the transient <code>disconnected</code> state, the state transitions instead to <code>checking</code>, essentially indicating that the negotiation is ignoring the fact that the connection had been temporarily lost.</p>

<h3 id="State_transitions_as_negotiation_ends">State transitions as negotiation ends</h3>

<p>When the negotiation process runs out of candidates to check, the ICE connection transitions to one of two states. If no suitable candidates were found, the state transitions to <code>failed</code>. If at least one suitable candidate was successfully identified, the state transitions to <code>completed</code>. The ICE layer makes this determination upon receiving the end-of-candidates signal, which is provided by caling {{domxref("RTCPeerConnection.addIceCandidate", "addIceCandidate()")}} with a candidate whose {{domxref("RTCIceCandidate.candidate", "candidate")}} property is an empty string (""), or by setting the {{domxref("RTCPeerConnection")}} property {{domxref("RTCPeerConnection.canTrickleIceCandidates", "canTrickleIceCandidates")}} to <code>false</code>.</p>

<h2 id="Examples">Examples</h2>

<p>An event handler for this event can be added using the {{domxref("RTCPeerConnection.oniceconnectionstatechange")}} property or by using {{domxref("EventTarget.addEventListener", "addEventListener()")}} on the <code>RTCPeerConnection</code>.</p>

<p>In this example, a handler for <code>iceconnectionstatechange</code> is set up to update a call state indicator by using the value of {{domxref("RTCPeerConnection.iceConnectionState", "iceConnectionState")}} to create a string which corresponds to the name of a CSS class that we can assign to the status indicator to cause it to reflect the current state of the connection.</p>

<pre class="brush: js">pc.addEventListener("iceconnectionstatechange", ev =&gt; {
  let stateElem = document.querySelector("#call-state");
  stateElem.className = `${pc.iceConnectionState}-state`;
}, false);
</pre>

<p>This can also be written as:</p>

<pre class="brush: js">pc.oniceconnectionstatechange = ev =&gt; {
  let stateElem = document.querySelector("#call-state");
  stateElem.className = `${pc.iceConnectionState}-state`;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#event-iceconnectionstatechange', 'iceconnectionstatechange') }}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.iceconnectionstatechange_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API" title="/en-US/docs/CSS/Using_CSS_animations">WebRTC API</a></li>
 <li>{{domxref("RTCPeerConnection")}}</li>
 <li>{{domxref("RTCPeerConnection.onIceConnectionStateChange")}}</li>
 <li>{{domxref("RTCPeerConnection.iceConnectionState")}}</li>
</ul>
